#!/usr/bin/env python

import cairocffi as cairo

if __name__ == "__main__":
    recording_surface = cairo.RecordingSurface(cairo.CONTENT_COLOR_ALPHA, None)
    cr = cairo.Context(recording_surface)

    cr.set_source_rgb(1, 0, 0)
    cr.set_line_width(2)

    cr.move_to(0, 0)
    # move right
    cr.rel_line_to(10, 0)
    # move down
    cr.rel_line_to(0, 10)
    # move left
    cr.rel_line_to(-10, 0)
    # move left again, draw to negative extents
    cr.rel_line_to(-10, 0)
    cr.stroke()

    x0, y0, width, height = recording_surface.ink_extents()

    print "x0: %lf y0: %lf width: %lf height: %lf" % (x0, y0, width, height)

    # offset the source surface in order to draw all of it
    use_offset = True
    if use_offset:
        x = -x0
        y = -y0
    else:
        x = 0
        y = 0

    # Saving to PNG
    png_surface = cairo.ImageSurface(cairo.FORMAT_ARGB32, int(width), int(height))
    png_cr = cairo.Context(png_surface)
    png_cr.set_source_surface(recording_surface, x, y)
    png_cr.paint()
    png_surface.write_to_png("python.png")

    # Saving to SVG does not seem right
    svg_surface = cairo.SVGSurface('python.svg', int(width), int(height))
    svg_cr = cairo.Context(svg_surface)
    svg_cr.set_source_surface(recording_surface, x, y)
    svg_cr.paint()
